diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/examples/main-test-sync.cc ns-3.31/src/core/examples/main-test-sync.cc
--- ns-3.30.1/src/core/examples/main-test-sync.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/examples/main-test-sync.cc	2020-06-27 17:38:30.000000000 -0700
@@ -46,33 +46,33 @@
 NS_LOG_COMPONENT_DEFINE ("TestSync");
 
 namespace {
-  
+
 /** Check that the event functions run in the intended order. */
 bool gFirstRun = false;
 
 /** An event method called many times from the background thread. */
-void 
+void
 inserted_function (void)
 {
   NS_ASSERT (gFirstRun);
-  NS_LOG_UNCOND ("inserted_function() called at " << 
+  NS_LOG_UNCOND ("inserted_function() called at " <<
                  Simulator::Now ().GetSeconds () << " s");
 }
 
 /** An event method called many times from the main thread. */
-void 
+void
 background_function (void)
 {
   NS_ASSERT (gFirstRun);
-  NS_LOG_UNCOND ("background_function() called at " << 
+  NS_LOG_UNCOND ("background_function() called at " <<
                  Simulator::Now ().GetSeconds () << " s");
 }
 
 /** An event method called once from the main thread. */
-void 
+void
 first_function (void)
 {
-  NS_LOG_UNCOND ("first_function() called at " << 
+  NS_LOG_UNCOND ("first_function() called at " <<
                  Simulator::Now ().GetSeconds () << " s");
   gFirstRun = true;
 }
@@ -96,15 +96,15 @@
 FakeNetDevice::Doit3 (void)
 {
   NS_LOG_FUNCTION_NOARGS ();
-  std::this_thread::sleep_for (std::chrono::seconds(1));
+  std::this_thread::sleep_for (std::chrono::seconds (1));
 
   for (uint32_t i = 0; i < 10000; ++i)
     {
       //
       // Exercise the realtime relative now path
       //
-      Simulator::ScheduleWithContext(Simulator::NO_CONTEXT, Seconds(0.0), MakeEvent (&inserted_function));
-      std::this_thread::sleep_for (std::chrono::milliseconds(1));
+      Simulator::ScheduleWithContext (Simulator::NO_CONTEXT, Seconds (0.0), MakeEvent (&inserted_function));
+      std::this_thread::sleep_for (std::chrono::milliseconds (1));
     }
 }
 
@@ -117,20 +117,20 @@
  * thread with an instance of FakeNetDevice, which schedules many instances of
  * \c inserted_function.
  */
-void 
+void
 test (void)
 {
-  GlobalValue::Bind ("SimulatorImplementationType", 
+  GlobalValue::Bind ("SimulatorImplementationType",
                      StringValue ("ns3::RealtimeSimulatorImpl"));
 
   FakeNetDevice fnd;
 
-  // 
+  //
   // Make sure ScheduleNow works when the system isn't running
   //
-  Simulator::ScheduleWithContext(0xffffffff, Seconds(0.0), MakeEvent (&first_function));
+  Simulator::ScheduleWithContext (0xffffffff, Seconds (0.0), MakeEvent (&first_function));
 
-  // 
+  //
   // drive the progression of m_currentTs at a ten millisecond rate from the main thread
   //
   for (double d = 0.; d < 14.999; d += 0.01)
@@ -139,7 +139,7 @@
     }
 
   Ptr<SystemThread> st3 = Create<SystemThread> (
-      MakeCallback (&FakeNetDevice::Doit3, &fnd));
+    MakeCallback (&FakeNetDevice::Doit3, &fnd));
   st3->Start ();
 
   Simulator::Stop (Seconds (15.0));
@@ -154,9 +154,9 @@
 int
 main (int argc, char *argv[])
 {
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
-  
+
   while (true)
     {
       test ();
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/examples/sample-log-time-format.cc ns-3.31/src/core/examples/sample-log-time-format.cc
--- ns-3.30.1/src/core/examples/sample-log-time-format.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/examples/sample-log-time-format.cc	2020-06-27 17:38:30.000000000 -0700
@@ -25,7 +25,7 @@
  * Example program that demonstrates how to replace the time printer.
  *
  * This program creates a sample object and schedules some methods to
- * occur at future times.  When run with no arguments, it prints out 
+ * occur at future times.  When run with no arguments, it prints out
  * something like this:
  * \code
  * $ ./waf --run sample-log-time-format
@@ -56,7 +56,7 @@
  * once the simulator object is instantiated (after Simulator::Run ()
  * is called).
  *
- * To change the format, one can schedule (at simulation time 0) a 
+ * To change the format, one can schedule (at simulation time 0) a
  * replacement function for printing time.  This can be demonstrated
  * by setting the 'replace-time-printer' parameter to true:
  * \code
@@ -77,10 +77,10 @@
  * (which was the default for ns-3 versions 3.26 and earlier).
  *
  * In addition, the 'resolution' program argument allows one to experiment
- * with changing ns-3's time resolution from its default of Time::NS, such 
+ * with changing ns-3's time resolution from its default of Time::NS, such
  * as Time::PS or Time::FS; the precision changes accordingly.
  *
- * The maximum useful precision is 20 decimal digits, since Time is 
+ * The maximum useful precision is 20 decimal digits, since Time is
  * signed 64 bits.
  */
 
@@ -93,10 +93,10 @@
 using namespace ns3;
 
 namespace {
-  
+
 /**
  * Pre-ns-3.26 TimePrinter equivalent (was called LogTimePrinter).
- * 
+ *
  * Prior to ns-3.26, the time printer used default C++ iostream precision
  * This function sets it back to the format used before ns-3.26
  *
@@ -129,7 +129,7 @@
 
   std::map<std::string, Time::Unit> resolutionMap = {{"Time::US", Time::US}, {"Time::NS", Time::NS}, {"Time::PS", Time::PS}, {"Time::FS", Time::FS}};
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("replaceTimePrinter", "replace time printing function", replaceTimePrinter);
   cmd.AddValue ("resolution", "time resolution", resolution);
   cmd.Parse (argc, argv);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/examples/sample-random-variable.cc ns-3.31/src/core/examples/sample-random-variable.cc
--- ns-3.30.1/src/core/examples/sample-random-variable.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/examples/sample-random-variable.cc	2020-06-27 17:38:30.000000000 -0700
@@ -31,35 +31,35 @@
 /**
  * This program can be run from waf such as
  * `./waf --run sample-random-variable`
- * 
- * This program is about as simple as possible to display the use of ns-3 
+ *
+ * This program is about as simple as possible to display the use of ns-3
  * to generate random numbers.  By default, the uniform random variate that
  * will be outputted is 0.816532.  Because ns-3 uses a fixed seed for the
  * pseudo-random number generator, this program should always output the
  * same number.  Likewise, ns-3 simulations using random variables will
  * behave deterministically unless the user changes the Run number or the
  * Seed.
- * 
+ *
  * There are three primary mechanisms to change the seed or run numbers
  * from their default integer value of 1:
  *
- * 1. Through explicit call of SeedManager::SetSeed () and 
- *    SeedManager::SetRun () (commented out below) 
+ * 1. Through explicit call of SeedManager::SetSeed () and
+ *    SeedManager::SetRun () (commented out below)
  * 2. Through the passing of command line arguments such as:
  *    ./waf --command-template="%s --RngRun=<value>" --run program-name`
  * 3. Through the use of the NS_GLOBAL_VALUE environment variable, such as:
  *    `$ NS_GLOBAL_VALUE="RngRun=<value>" ./waf --run program-name`
- * 
+ *
  * For instance, setting the run number to 3 will change the program output to
  * 0.775417
- * 
- * Consult the ns-3 manual for more information about the use of the 
+ *
+ * Consult the ns-3 manual for more information about the use of the
  * random number generator
  */
 
 int main (int argc, char *argv[])
 {
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
 
   // SeedManager::SetRun (3);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/examples/sample-random-variable-stream.cc ns-3.31/src/core/examples/sample-random-variable-stream.cc
--- ns-3.30.1/src/core/examples/sample-random-variable-stream.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/examples/sample-random-variable-stream.cc	2020-06-27 17:38:30.000000000 -0700
@@ -29,29 +29,29 @@
  *
  * This program can be run from waf such as
  * `./waf --run sample-random-variable-stream`
- * 
- * This program is about as simple as possible to display the use of ns-3 
+ *
+ * This program is about as simple as possible to display the use of ns-3
  * to generate random numbers.  By default, the uniform random variate that
  * will be printed is 0.816532.  Because ns-3 uses a fixed seed for the
  * pseudo-random number generator, this program should always output the
  * same number.  Likewise, ns-3 simulations using random variables will
  * behave deterministically unless the user changes the Run number or the
  * Seed.
- * 
+ *
  * There are three primary mechanisms to change the seed or run numbers
  * from their default integer value of 1:
- * 
- * 1. Through explicit call of SeedManager::SetSeed () and 
- *    SeedManager::SetRun () (commented out below) 
+ *
+ * 1. Through explicit call of SeedManager::SetSeed () and
+ *    SeedManager::SetRun () (commented out below)
  * 2. Through the passing of command line arguments such as:
  *    `./waf --command-template="%s --RngRun=<value>" --run program-name`
  * 3. Through the use of the NS_GLOBAL_VALUE environment variable, such as:
  *    `$ NS_GLOBAL_VALUE="RngRun=<value>" ./waf --run program-name`
- * 
+ *
  * For instance, setting the run number to 3 will change the program output to
  * 0.775417
- * 
- * Consult the ns-3 manual for more information about the use of the 
+ *
+ * Consult the ns-3 manual for more information about the use of the
  * random number generator
  */
 
@@ -59,7 +59,7 @@
 
 int main (int argc, char *argv[])
 {
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
 
   // SeedManager::SetRun (3);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/examples/sample-show-progress.cc ns-3.31/src/core/examples/sample-show-progress.cc
--- ns-3.30.1/src/core/examples/sample-show-progress.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/examples/sample-show-progress.cc	2020-06-27 17:38:30.000000000 -0700
@@ -44,61 +44,48 @@
 
 namespace {
 
-class Timestamp
-{
- public:
-  Timestamp () :
-    last(0),
-    diff(0)
-  {
-    stamp ();
-  }
-  
-  void stamp () {
-    time_t seconds  = time (NULL);
-    diff = seconds - last;
-    last  = seconds;
-  }
-
-  std::string string () {
-    std::string now = ctime ( &last );
-    now.resize(now.length () - 1);  // trim trailing newline
-    return now;
-  }
-
-  time_t last;
-  time_t diff;
-
-};  // class Timestamp
-
-  
 /**
- * Execute a function periodically.
+ * Execute a function periodically,
+ * which takes more or less time to run.
+ *
+ * Inspired by PHOLD.
  */
 class Hold : public SimpleRefCount<Hold>
 {
 public:
-  
+
+  /**
+   * Create a Hold with mean inter-event time \pname{wait},
+   * changing workload every \pname{interval}.
+   * \param wait The mean inter-event time.
+   * \param interval How often to change work load.  This
+   *                 should be an order of magnitude larger than \pname{wait}.
+   */
   Hold (Time wait, Time interval)
   {
     m_wait = wait;
     m_interval = interval;
 
     m_rng = CreateObject<ExponentialRandomVariable> ();
-    m_rng->SetAttribute ("Mean", DoubleValue (wait.GetSeconds ()));
+    m_rng->SetAttribute ("Mean", DoubleValue (m_wait.GetSeconds ()));
   }
 
+  /**
+   * Create a hold with a specified random number generator for the
+   * \pname{wait} time.  The RNG value will be interpreted as seconds.
+   * \param rng The random variable generator to use for the inter-event time.
+   */
   Hold (Ptr<RandomVariableStream> rng)
     : m_rng (rng)
-  {
-  }
+  {}
 
+  /** The Hold event. */
   void Event (void)
   {
     double delta = m_rng->GetValue ();
     Time delay = Seconds (delta);
     NS_LOG_LOGIC ("event delay: " << delay);
-    
+
     Simulator::Schedule (delay, &Hold::Event, this);
 
     // Switch work load every 10 * m_interval of simulation time
@@ -106,13 +93,17 @@
     bool even = (ratio.GetHigh () % 2);
     Time work = m_wait * (even ? 3 : 1);
     m_condition.TimedWait ( work.GetNanoSeconds () );
-    
+
   }
-  
+
 private:
+  /** The random number generator for the interval between events. */
   Ptr<RandomVariableStream> m_rng;
+  /** Timer to represent workload. */
   SystemCondition m_condition;
+  /** Mean inter-event time. */
   Time m_wait;
+  /** Time between switching workloads. */
   Time m_interval;
 
 };  // class HOLD
@@ -124,11 +115,11 @@
 main (int argc, char ** argv)
 {
   Time stop = Seconds (100);
-  Time interval = Seconds (1);
+  Time interval = Seconds (10);
   Time wait = MilliSeconds (10);
   bool verbose = false;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("stop", "Simulation duration in virtual time.", stop);
   cmd.AddValue ("interval", "Approximate reporting interval, in wall clock time.", interval);
   cmd.AddValue ("wait", "Wallclock time to burn on each event.", wait);
@@ -143,7 +134,7 @@
             << "average event sleep time:  " << wait.As (Time::MS)    << "\n"
             << "total simulation run time: " << stop.As (Time::S)
             << std::endl;
-  
+
   Ptr<Hold> h = Create<Hold> (wait, interval);
   h->Event ();
 
@@ -151,20 +142,7 @@
   ShowProgress spinner (interval);
   spinner.SetVerbose (verbose);
 
-  Timestamp ts;
-  ts.stamp ();
-
-  std::cout << std::endl;
-  std::cout << "Start wall clock:   " << ts.string ()
-            << " (" << ts.last << ")"
-            << std::endl;
-  
   Simulator::Run ();
-
-  ts.stamp ();
-  std::cout << "Elapsed wall clock: " << ts.diff << "s" << std::endl;
-
-  
   Simulator::Destroy ();
 
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/examples/sample-simulator.cc ns-3.31/src/core/examples/sample-simulator.cc
--- ns-3.30.1/src/core/examples/sample-simulator.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/examples/sample-simulator.cc	2020-06-27 17:38:30.000000000 -0700
@@ -35,13 +35,14 @@
 using namespace ns3;
 
 namespace {
-  
+
 /** Simple model object to illustrate event handling. */
 class MyModel
 {
 public:
   /** Start model execution by scheduling a HandleEvent. */
   void Start (void);
+
 private:
   /**
    *  Simple event handler.
@@ -101,7 +102,7 @@
 
 int main (int argc, char *argv[])
 {
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
 
   MyModel model;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/examples/system-path-examples.cc ns-3.31/src/core/examples/system-path-examples.cc
--- ns-3.30.1/src/core/examples/system-path-examples.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/core/examples/system-path-examples.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,86 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
+ */
+
+#include <iostream>
+#include <iomanip>
+#include <string>
+
+#include "ns3/core-module.h"
+
+/**
+ * \file
+ * \ingroup core-examples
+ * \ingroup systempath
+ * Example program illustrating use of ns3::SystemPath
+ */
+
+using namespace ns3;
+using namespace ns3::SystemPath;
+
+int main (int argc, char *argv[])
+{
+  std::string path = "/usr/share/dict/";
+
+  CommandLine cmd;
+  cmd.Usage ("SystemPath examples.\n");
+
+  cmd.AddValue ("path", "Path to demonstrate SystemPath functions.", path);
+  cmd.Parse (argc, argv);
+
+  // Show initial values:
+  std::cout << std::endl;
+  std::cout << cmd.GetName () << ":" << std::endl;
+
+  std::cout << "FindSelfDirectory:   " << FindSelfDirectory () << std::endl;
+
+  std::cout << "Demonstration path:  " << path << std::endl;
+  std::cout << "Exists?              "
+            << (Exists (path) ? "yes" : "no") << std::endl;
+
+  auto foo = Append (path, "foo");
+  std::cout << "Append 'foo':        " << foo << std::endl;
+  std::cout << "Exists?              "
+            << (Exists (foo) ? "yes" : "no") << std::endl;
+
+  std::cout << "Split path:\n";
+  auto items = Split (path);
+  for (auto item : items)
+    {
+      std::cout << "    '" << item << "'\n";
+    }
+  std::cout << std::endl;
+
+  std::cout << "Successive Joins: \n";
+  for (auto it = items.begin (); it != items.end (); ++it)
+    {
+      auto partial = Join (items.begin (), it);
+      std::cout << "    '" << partial << "'\n";
+    }
+
+  std::cout << "Files in the directory: \n";
+  auto files = ReadFiles (path);
+  for (auto item : files)
+    {
+      std::cout << "    '" << item << "'\n";
+    }
+
+
+  return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/examples/test-string-value-formatting.cc ns-3.31/src/core/examples/test-string-value-formatting.cc
--- ns-3.30.1/src/core/examples/test-string-value-formatting.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/examples/test-string-value-formatting.cc	2020-06-27 17:38:30.000000000 -0700
@@ -36,7 +36,7 @@
 NS_LOG_COMPONENT_DEFINE ("TestStringValueFormatting");
 
 namespace {
-  
+
 /**
  * \ingroup string-value-formatting
  *
@@ -60,6 +60,7 @@
    * \returns the test variable
    */
   Ptr<RandomVariableStream> GetTestVariable (void) const;
+
 private:
   Ptr<RandomVariableStream> m_testVariable; //!< The test variable
 };
@@ -81,8 +82,7 @@
 }
 
 FormattingTestObject::FormattingTestObject ()
-{
-}
+{}
 
 Ptr<RandomVariableStream>
 FormattingTestObject::GetTestVariable (void) const
@@ -104,13 +104,14 @@
    * Set an attribute by name
    * \param name the attribute
    * \param value the attribute value
-   */ 
+   */
   void SetAttribute (std::string name, const AttributeValue &value);
   /**
    * Create an Object as configured by SetAttribute
    * \returns the newly created Object
    */
   Ptr<Object> CreateFromFactory (void);
+
 private:
   ObjectFactory m_factory; //!< Object factory
 };
@@ -135,7 +136,7 @@
 }  // unnamed namespace
 
 
-int 
+int
 main (int argc, char *argv[])
 {
   // CreateObject parsing
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/examples/wscript ns-3.31/src/core/examples/wscript
--- ns-3.30.1/src/core/examples/wscript	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/examples/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -44,6 +44,13 @@
                                  ['core'])
     obj.source = 'sample-show-progress.cc'
 
+    obj = bld.create_ns3_program('empirical-random-variable-example', ['core', 'flow-monitor'])
+    obj.source = 'empirical-random-variable-example.cc'
+    
+    obj = bld.create_ns3_program('system-path-examples',
+                                 ['core'])
+    obj.source = 'system-path-examples.cc'
+
     if bld.env['ENABLE_THREADING'] and bld.env["ENABLE_REAL_TIME"]:
         obj = bld.create_ns3_program('main-test-sync', ['network'])
         obj.source = 'main-test-sync.cc'
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/helper/event-garbage-collector.cc ns-3.31/src/core/helper/event-garbage-collector.cc
--- ns-3.30.1/src/core/helper/event-garbage-collector.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/helper/event-garbage-collector.cc	2020-06-27 17:38:30.000000000 -0700
@@ -32,15 +32,16 @@
 EventGarbageCollector::EventGarbageCollector ()
   : m_nextCleanupSize (CHUNK_INIT_SIZE),
     m_events ()
-{
-}
+{}
 
 void
 EventGarbageCollector::Track (EventId event)
 {
   m_events.insert (event);
   if (m_events.size () >= m_nextCleanupSize)
-    Cleanup ();
+    {
+      Cleanup ();
+    }
 }
 
 void
@@ -54,7 +55,9 @@
 EventGarbageCollector::Shrink ()
 {
   while (m_nextCleanupSize > m_events.size ())
-    m_nextCleanupSize >>= 1;
+    {
+      m_nextCleanupSize >>= 1;
+    }
   Grow ();
 }
 
@@ -70,14 +73,20 @@
           m_events.erase (iter++);
         }
       else
-        break;  // EventIds are sorted by timestamp => further events are not expired for sure
+        {
+          break; // EventIds are sorted by timestamp => further events are not expired for sure
+        }
     }
 
   // If after cleanup we are still over the limit, increase the limit.
   if (m_events.size () >= m_nextCleanupSize)
-    Grow ();
+    {
+      Grow ();
+    }
   else
-    Shrink ();
+    {
+      Shrink ();
+    }
 }
 
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/ascii-file.cc ns-3.31/src/core/model/ascii-file.cc
--- ns-3.30.1/src/core/model/ascii-file.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/core/model/ascii-file.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,130 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2012 University of Washington
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mitch Watrous (watrous@u.washington.edu)
+ *
+ * This file is based on pcap-file.cc by Craig Dowell (craigdo@ee.washington.edu)
+ */
+
+#include "ascii-file.h"
+#include "assert.h"
+#include "fatal-error.h"
+#include "fatal-impl.h"
+#include <iostream>
+#include <string>
+
+//
+// This file is used as part of the ns-3 test framework, so please refrain from
+// adding any ns-3 specific constructs such as Packet to this file.
+//
+namespace ns3 {
+
+AsciiFile::AsciiFile ()
+  : m_file ()
+{
+  FatalImpl::RegisterStream (&m_file);
+}
+
+AsciiFile::~AsciiFile ()
+{
+  FatalImpl::UnregisterStream (&m_file);
+  Close ();
+}
+
+bool
+AsciiFile::Fail (void) const
+{
+  return m_file.fail ();
+}
+bool
+AsciiFile::Eof (void) const
+{
+  return m_file.eof ();
+}
+
+void
+AsciiFile::Close (void)
+{
+  m_file.close ();
+}
+
+void
+AsciiFile::Open (std::string const &filename, std::ios::openmode mode)
+{
+  NS_ASSERT ((mode & std::ios::app) == 0);
+  NS_ASSERT (!m_file.fail ());
+
+  m_file.open (filename.c_str (), mode);
+}
+
+void
+AsciiFile::Read (std::string& line)
+{
+  NS_ASSERT (m_file.good ());
+
+  // Read the next line.
+  getline (m_file, line);
+}
+
+bool
+AsciiFile::Diff (std::string const & f1,
+                 std::string const & f2,
+                 uint64_t & lineNumber)
+{
+  AsciiFile ascii1, ascii2;
+  ascii1.Open (f1, std::ios::in);
+  ascii2.Open (f2, std::ios::in);
+  bool bad = ascii1.Fail () || ascii2.Fail ();
+  if (bad)
+    {
+      return true;
+    }
+
+  std::string line1;
+  std::string line2;
+  lineNumber = 0;
+  bool diff = false;
+
+  while (!ascii1.Eof () && !ascii2.Eof ())
+    {
+      ascii1.Read (line1);
+      ascii2.Read (line2);
+
+      lineNumber++;
+
+      bool same = ascii1.Fail () == ascii2.Fail ();
+      if (!same)
+        {
+          diff = true;
+          break;
+        }
+      if (ascii1.Eof ())
+        {
+          break;
+        }
+
+      if (line1 != line2)
+        {
+          diff = true; // Lines do not match
+          break;
+        }
+    }
+
+  return diff;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/ascii-file.h ns-3.31/src/core/model/ascii-file.h
--- ns-3.30.1/src/core/model/ascii-file.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/core/model/ascii-file.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,94 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2012 University of Washington
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mitch Watrous (watrous@u.washington.edu)
+ *
+ * This file is based on pcap-file.h by Craig Dowell (craigdo@ee.washington.edu)
+ */
+
+#ifndef ASCII_FILE_H
+#define ASCII_FILE_H
+
+#include <string>
+#include <fstream>
+#include <stdint.h>
+
+namespace ns3 {
+
+
+/**
+ * \brief A class representing an ascii file.
+ *
+ * This class represents an ascii file
+ */
+class AsciiFile
+{
+public:
+  AsciiFile ();
+  ~AsciiFile ();
+
+  /**
+   * \return true if the 'fail' bit is set in the underlying iostream, false otherwise.
+   */
+  bool Fail (void) const;
+  /**
+   * \return true if the 'eof' bit is set in the underlying iostream, false otherwise.
+   */
+  bool Eof (void) const;
+
+  /**
+   * Create a new ascii file or open an existing ascii file.
+   *
+   * \param filename String containing the name of the file.
+   * \param mode the access mode for the file.
+   */
+  void Open (std::string const &filename, std::ios::openmode mode);
+
+  /**
+   * Close the underlying file.
+   */
+  void Close (void);
+
+  /**
+   * \brief Read next line from file
+   *
+   * \param line    [out] line from file
+   *
+   */
+  void Read (std::string& line);
+
+  /**
+   * \brief Compare two ASCII files line-by-line
+   *
+   * \return true if files are different, false otherwise
+   *
+   * \param  f1         First ASCII file name
+   * \param  f2         Second ASCII file name
+   * \param  lineNumber   [out] Line number of first different line.
+   */
+  static bool Diff (std::string const & f1,
+                    std::string const & f2,
+                    uint64_t & lineNumber);
+
+private:
+  std::string    m_filename; //!< output file name
+  std::fstream   m_file;     //!< output file
+};
+
+} // namespace ns3
+
+#endif /* ASCII_FILE_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/ascii-test.h ns-3.31/src/core/model/ascii-test.h
--- ns-3.30.1/src/core/model/ascii-test.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/core/model/ascii-test.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,49 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2012 University of Washington
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mitch Watrous (watrous@u.washington.edu)
+ *
+ * This file is based on pcap-test.h by Craig Dowell (craigdo@ee.washington.edu)
+ */
+
+#ifndef ASCII_TEST_H
+#define ASCII_TEST_H
+
+#include <stdint.h>
+#include "ascii-file.h"
+#include "ns3/test.h"
+
+/**
+ * \brief Test that a pair of new/reference ascii files are equal
+ *
+ * \param gotFilename The name of the new file to read in including
+ * its path
+ * \param expectedFilename The name of the reference file to read in
+ * including its path
+ */
+#define NS_ASCII_TEST_EXPECT_EQ(gotFilename, expectedFilename)          \
+  do {                                                                  \
+      uint64_t line (0);                                                   \
+      bool diff = AsciiFile::Diff (gotFilename, expectedFilename, line);  \
+      NS_TEST_EXPECT_MSG_EQ (diff, false,                                 \
+                             "ASCII traces " << gotFilename <<            \
+                             " and " << expectedFilename <<               \
+                             " differ starting from line " << line);      \
+    } while (false)
+
+
+#endif /* ASCII_TEST_H */
